Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/params-5.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/params-5.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/params-5.dot
@@ -1,10 +1,13 @@
 digraph "g" {
 "Cancel rsc_c001n02_monitor_5000 c001n02" [ style=bold color="green" fontcolor="black"]
 "DcIPaddr_monitor_0 c001n01" -> "DcIPaddr_start_0 c001n02" [ style = bold]
+"DcIPaddr_monitor_0 c001n01" -> "all_stopped" [ style = bold]
 "DcIPaddr_monitor_0 c001n01" [ style=bold color="green" fontcolor="black"]
 "DcIPaddr_monitor_0 c001n03" -> "DcIPaddr_start_0 c001n02" [ style = bold]
+"DcIPaddr_monitor_0 c001n03" -> "all_stopped" [ style = bold]
 "DcIPaddr_monitor_0 c001n03" [ style=bold color="green" fontcolor="black"]
 "DcIPaddr_monitor_0 c001n08" -> "DcIPaddr_start_0 c001n02" [ style = bold]
+"DcIPaddr_monitor_0 c001n08" -> "all_stopped" [ style = bold]
 "DcIPaddr_monitor_0 c001n08" [ style=bold color="green" fontcolor="black"]
 "DcIPaddr_monitor_5000 c001n02" [ style=bold color="green" fontcolor="black"]
 "DcIPaddr_start_0 c001n02" -> "DcIPaddr_monitor_5000 c001n02" [ style = bold]
@@ -13,18 +16,30 @@ digraph "g" {
 "DcIPaddr_stop_0 c001n02" -> "all_stopped" [ style = bold]
 "DcIPaddr_stop_0 c001n02" [ style=bold color="green" fontcolor="black"]
 "all_stopped" [ style=bold color="green" fontcolor="orange"]
+"rsc_c001n01_monitor_0 c001n02" -> "all_stopped" [ style = bold]
 "rsc_c001n01_monitor_0 c001n02" [ style=bold color="green" fontcolor="black"]
+"rsc_c001n01_monitor_0 c001n03" -> "all_stopped" [ style = bold]
 "rsc_c001n01_monitor_0 c001n03" [ style=bold color="green" fontcolor="black"]
+"rsc_c001n01_monitor_0 c001n08" -> "all_stopped" [ style = bold]
 "rsc_c001n01_monitor_0 c001n08" [ style=bold color="green" fontcolor="black"]
+"rsc_c001n02_monitor_0 c001n01" -> "all_stopped" [ style = bold]
 "rsc_c001n02_monitor_0 c001n01" [ style=bold color="green" fontcolor="black"]
+"rsc_c001n02_monitor_0 c001n03" -> "all_stopped" [ style = bold]
 "rsc_c001n02_monitor_0 c001n03" [ style=bold color="green" fontcolor="black"]
+"rsc_c001n02_monitor_0 c001n08" -> "all_stopped" [ style = bold]
 "rsc_c001n02_monitor_0 c001n08" [ style=bold color="green" fontcolor="black"]
 "rsc_c001n02_monitor_6000 c001n02" [ style=bold color="green" fontcolor="black"]
+"rsc_c001n03_monitor_0 c001n01" -> "all_stopped" [ style = bold]
 "rsc_c001n03_monitor_0 c001n01" [ style=bold color="green" fontcolor="black"]
+"rsc_c001n03_monitor_0 c001n02" -> "all_stopped" [ style = bold]
 "rsc_c001n03_monitor_0 c001n02" [ style=bold color="green" fontcolor="black"]
+"rsc_c001n03_monitor_0 c001n08" -> "all_stopped" [ style = bold]
 "rsc_c001n03_monitor_0 c001n08" [ style=bold color="green" fontcolor="black"]
+"rsc_c001n08_monitor_0 c001n01" -> "all_stopped" [ style = bold]
 "rsc_c001n08_monitor_0 c001n01" [ style=bold color="green" fontcolor="black"]
+"rsc_c001n08_monitor_0 c001n02" -> "all_stopped" [ style = bold]
 "rsc_c001n08_monitor_0 c001n02" [ style=bold color="green" fontcolor="black"]
+"rsc_c001n08_monitor_0 c001n03" -> "all_stopped" [ style = bold]
 "rsc_c001n08_monitor_0 c001n03" [ style=bold color="green" fontcolor="black"]
 "rsc_c001n08_monitor_5000 c001n08" [ style=bold color="green" fontcolor="black"]
 }
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/params-5.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/params-5.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/params-5.exp
@@ -213,6 +213,51 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="8" operation="monitor" operation_key="DcIPaddr_monitor_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="9" operation="monitor" operation_key="rsc_c001n08_monitor_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="10" operation="monitor" operation_key="rsc_c001n02_monitor_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="11" operation="monitor" operation_key="rsc_c001n03_monitor_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="12" operation="monitor" operation_key="rsc_c001n08_monitor_0" on_node="c001n02" on_node_uuid="e9bdfde9-01b0-421f-acd8-8a65a53e775f"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="13" operation="monitor" operation_key="rsc_c001n03_monitor_0" on_node="c001n02" on_node_uuid="e9bdfde9-01b0-421f-acd8-8a65a53e775f"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="14" operation="monitor" operation_key="rsc_c001n01_monitor_0" on_node="c001n02" on_node_uuid="e9bdfde9-01b0-421f-acd8-8a65a53e775f"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="15" operation="monitor" operation_key="DcIPaddr_monitor_0" on_node="c001n03" on_node_uuid="5d9a8c11-8684-43ea-91.0.6e221530c193"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="16" operation="monitor" operation_key="rsc_c001n08_monitor_0" on_node="c001n03" on_node_uuid="5d9a8c11-8684-43ea-91.0.6e221530c193"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="17" operation="monitor" operation_key="rsc_c001n02_monitor_0" on_node="c001n03" on_node_uuid="5d9a8c11-8684-43ea-91.0.6e221530c193"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="18" operation="monitor" operation_key="rsc_c001n01_monitor_0" on_node="c001n03" on_node_uuid="5d9a8c11-8684-43ea-91.0.6e221530c193"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="19" operation="monitor" operation_key="DcIPaddr_monitor_0" on_node="c001n08" on_node_uuid="6427cb5a-c7a5-4bdf-9892-a04ce56f4e6b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="20" operation="monitor" operation_key="rsc_c001n02_monitor_0" on_node="c001n08" on_node_uuid="6427cb5a-c7a5-4bdf-9892-a04ce56f4e6b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="21" operation="monitor" operation_key="rsc_c001n03_monitor_0" on_node="c001n08" on_node_uuid="6427cb5a-c7a5-4bdf-9892-a04ce56f4e6b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="22" operation="monitor" operation_key="rsc_c001n01_monitor_0" on_node="c001n08" on_node_uuid="6427cb5a-c7a5-4bdf-9892-a04ce56f4e6b"/>
+      </trigger>
+      <trigger>
         <rsc_op id="23" operation="stop" operation_key="DcIPaddr_stop_0" on_node="c001n02" on_node_uuid="e9bdfde9-01b0-421f-acd8-8a65a53e775f"/>
       </trigger>
     </inputs>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/quorum-1.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/quorum-1.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/quorum-1.dot
@@ -1,14 +1,18 @@
  digraph "g" {
 "all_stopped" [ style=bold color="green" fontcolor="orange" ]
+"rsc1_monitor_0 node2" -> "all_stopped" [ style = bold]
 "rsc1_monitor_0 node2" [ style=bold color="green" fontcolor="black" ]
+"rsc2_monitor_0 node2" -> "all_stopped" [ style = bold]
 "rsc2_monitor_0 node2" -> "rsc2_start_0 node2" [ style = bold]
 "rsc2_monitor_0 node2" [ style=bold color="green" fontcolor="black" ]
 "rsc2_start_0 node2" [ style=bold color="green" fontcolor="black" ]
 "rsc2_stop_0 node1" -> "all_stopped" [ style = bold]
 "rsc2_stop_0 node1" -> "rsc2_start_0 node2" [ style = bold]
 "rsc2_stop_0 node1" [ style=bold color="green" fontcolor="black" ]
+"rsc3_monitor_0 node1" -> "all_stopped" [ style = bold]
 "rsc3_monitor_0 node1" -> "rsc3_start_0 node1" [ style = bold]
 "rsc3_monitor_0 node1" [ style=bold color="green" fontcolor="black" ]
+"rsc3_monitor_0 node2" -> "all_stopped" [ style = bold]
 "rsc3_monitor_0 node2" -> "rsc3_start_0 node1" [ style = bold]
 "rsc3_monitor_0 node2" [ style=bold color="green" fontcolor="black" ]
 "rsc3_start_0 node1" [ style=bold color="green" fontcolor="black" ]
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/quorum-1.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/quorum-1.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/quorum-1.exp
@@ -84,6 +84,18 @@
      </action_set>
      <inputs>
        <trigger>
+        <rsc_op id="2" operation="monitor" operation_key="rsc3_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="rsc1_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="4" operation="monitor" operation_key="rsc2_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="5" operation="monitor" operation_key="rsc3_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="8" operation="stop" operation_key="rsc2_stop_0" on_node="node1" on_node_uuid="uuid1"/>
        </trigger>
      </inputs>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/quorum-2.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/quorum-2.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/quorum-2.dot
@@ -1,12 +1,16 @@
  digraph "g" {
 "all_stopped" [ style=bold color="green" fontcolor="orange" ]
+"rsc1_monitor_0 node2" -> "all_stopped" [ style = bold]
 "rsc1_monitor_0 node2" [ style=bold color="green" fontcolor="black" ]
+"rsc2_monitor_0 node2" -> "all_stopped" [ style = bold]
 "rsc2_monitor_0 node2" -> "rsc2_start_0 node2" [ style = bold]
 "rsc2_monitor_0 node2" [ style=bold color="green" fontcolor="black" ]
 "rsc2_start_0 node2" [ style=bold color="green" fontcolor="black" ]
 "rsc2_stop_0 node1" -> "all_stopped" [ style = bold]
 "rsc2_stop_0 node1" -> "rsc2_start_0 node2" [ style = bold]
 "rsc2_stop_0 node1" [ style=bold color="green" fontcolor="black" ]
+"rsc3_monitor_0 node1" -> "all_stopped" [ style = bold]
 "rsc3_monitor_0 node1" [ style=bold color="green" fontcolor="black" ]
+"rsc3_monitor_0 node2" -> "all_stopped" [ style = bold]
 "rsc3_monitor_0 node2" [ style=bold color="green" fontcolor="black" ]
 }
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/quorum-2.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/quorum-2.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/quorum-2.exp
@@ -68,6 +68,18 @@
     </action_set>
     <inputs>
        <trigger>
+        <rsc_op id="2" operation="monitor" operation_key="rsc3_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="rsc1_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="4" operation="monitor" operation_key="rsc2_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="5" operation="monitor" operation_key="rsc3_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="8" operation="stop" operation_key="rsc2_stop_0" on_node="node1" on_node_uuid="uuid1"/>
        </trigger>
      </inputs>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/quorum-3.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/quorum-3.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/quorum-3.dot
@@ -1,17 +1,21 @@
  digraph "g" {
 "all_stopped" [ style=bold color="green" fontcolor="orange" ]
+"rsc1_monitor_0 node2" -> "all_stopped" [ style = bold]
 "rsc1_monitor_0 node2" -> "rsc1_start_0 node1" [ style = dashed]
 "rsc1_monitor_0 node2" [ style=bold color="green" fontcolor="black" ]
 "rsc1_start_0 node1" [ style=dashed color="red" fontcolor="black" ]
 "rsc1_stop_0 node1" -> "all_stopped" [ style = bold]
 "rsc1_stop_0 node1" -> "rsc1_start_0 node1" [ style = dashed]
 "rsc1_stop_0 node1" [ style=bold color="green" fontcolor="black" ]
+"rsc2_monitor_0 node2" -> "all_stopped" [ style = bold]
 "rsc2_monitor_0 node2" -> "rsc2_start_0 node2" [ style = dashed]
 "rsc2_monitor_0 node2" [ style=bold color="green" fontcolor="black" ]
 "rsc2_start_0 node2" [ style=dashed color="red" fontcolor="black" ]
 "rsc2_stop_0 node1" -> "all_stopped" [ style = bold]
 "rsc2_stop_0 node1" -> "rsc2_start_0 node2" [ style = dashed]
 "rsc2_stop_0 node1" [ style=bold color="green" fontcolor="black" ]
+"rsc3_monitor_0 node1" -> "all_stopped" [ style = bold]
 "rsc3_monitor_0 node1" [ style=bold color="green" fontcolor="black" ]
+"rsc3_monitor_0 node2" -> "all_stopped" [ style = bold]
 "rsc3_monitor_0 node2" [ style=bold color="green" fontcolor="black" ]
 }
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/quorum-3.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/quorum-3.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/quorum-3.exp
@@ -61,6 +61,18 @@
     </action_set>
     <inputs>
        <trigger>
+        <rsc_op id="2" operation="monitor" operation_key="rsc3_monitor_0" on_node="node1" on_node_uuid="uuid1"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="rsc1_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="4" operation="monitor" operation_key="rsc2_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="5" operation="monitor" operation_key="rsc3_monitor_0" on_node="node2" on_node_uuid="uuid2"/>
+      </trigger>
+      <trigger>
         <rsc_op id="6" operation="stop" operation_key="rsc1_stop_0" on_node="node1" on_node_uuid="uuid1"/>
       </trigger>
       <trigger>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/rec-node-10.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/rec-node-10.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/rec-node-10.dot
@@ -1,16 +1,19 @@
  digraph "g" {
 "all_stopped" [ style=dashed color="red" fontcolor="orange" ]
+"rsc1_monitor_0 node2" -> "all_stopped" [ style = dashed]
 "rsc1_monitor_0 node2" -> "rsc1_start_0 node2" [ style = dashed]
 "rsc1_monitor_0 node2" [ style=bold color="green" fontcolor="black" ]
 "rsc1_start_0 node2" [ style=dashed color="red" fontcolor="black" ]
 "rsc1_stop_0 node1" -> "all_stopped" [ style = dashed]
 "rsc1_stop_0 node1" -> "rsc1_start_0 node2" [ style = dashed]
 "rsc1_stop_0 node1" [ style=dashed color="red" fontcolor="black" ]
+"rsc2_monitor_0 node2" -> "all_stopped" [ style = dashed]
 "rsc2_monitor_0 node2" -> "rsc2_start_0 node2" [ style = dashed]
 "rsc2_monitor_0 node2" [ style=bold color="green" fontcolor="black" ]
 "rsc2_start_0 node2" [ style=dashed color="red" fontcolor="black" ]
 "rsc2_stop_0 node1" -> "all_stopped" [ style = dashed]
 "rsc2_stop_0 node1" -> "rsc2_start_0 node2" [ style = dashed]
 "rsc2_stop_0 node1" [ style=dashed color="red" fontcolor="black" ]
+"stonith-1_monitor_0 node2" -> "all_stopped" [ style = dashed]
 "stonith-1_monitor_0 node2" [ style=bold color="green" fontcolor="black" ]
 }
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/rec-node-12.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/rec-node-12.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/rec-node-12.dot
@@ -1,9 +1,12 @@
 digraph "g" {
 "DcIPaddr_monitor_0 c001n01" -> "DcIPaddr_start_0 c001n08" [ style = bold]
+"DcIPaddr_monitor_0 c001n01" -> "all_stopped" [ style = bold]
 "DcIPaddr_monitor_0 c001n01" [ style=bold color="green" fontcolor="black" ]
 "DcIPaddr_monitor_0 c001n03" -> "DcIPaddr_start_0 c001n08" [ style = bold]
+"DcIPaddr_monitor_0 c001n03" -> "all_stopped" [ style = bold]
 "DcIPaddr_monitor_0 c001n03" [ style=bold color="green" fontcolor="black" ]
 "DcIPaddr_monitor_0 c001n08" -> "DcIPaddr_start_0 c001n08" [ style = bold]
+"DcIPaddr_monitor_0 c001n08" -> "all_stopped" [ style = bold]
 "DcIPaddr_monitor_0 c001n08" [ style=bold color="green" fontcolor="black" ]
 "DcIPaddr_monitor_5000 c001n08" [ style=bold color="green" fontcolor="black" ]
 "DcIPaddr_start_0 c001n08" -> "DcIPaddr_monitor_5000 c001n08" [ style = bold]
@@ -16,72 +19,96 @@ digraph "g" {
 "DoFencing_start_0" [ style=bold color="green" fontcolor="orange" ]
 "all_stopped" [ style=bold color="green" fontcolor="orange" ]
 "child_DoFencing:0_monitor_0 c001n01" -> "DoFencing_start_0" [ style = bold]
+"child_DoFencing:0_monitor_0 c001n01" -> "all_stopped" [ style = bold]
 "child_DoFencing:0_monitor_0 c001n01" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:0_monitor_0 c001n03" -> "DoFencing_start_0" [ style = bold]
+"child_DoFencing:0_monitor_0 c001n03" -> "all_stopped" [ style = bold]
 "child_DoFencing:0_monitor_0 c001n03" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:0_monitor_0 c001n08" -> "DoFencing_start_0" [ style = bold]
+"child_DoFencing:0_monitor_0 c001n08" -> "all_stopped" [ style = bold]
 "child_DoFencing:0_monitor_0 c001n08" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:0_monitor_5000 c001n03" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:0_start_0 c001n03" -> "DoFencing_running_0" [ style = bold]
 "child_DoFencing:0_start_0 c001n03" -> "child_DoFencing:0_monitor_5000 c001n03" [ style = bold]
 "child_DoFencing:0_start_0 c001n03" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:1_monitor_0 c001n01" -> "DoFencing_start_0" [ style = bold]
+"child_DoFencing:1_monitor_0 c001n01" -> "all_stopped" [ style = bold]
 "child_DoFencing:1_monitor_0 c001n01" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:1_monitor_0 c001n03" -> "DoFencing_start_0" [ style = bold]
+"child_DoFencing:1_monitor_0 c001n03" -> "all_stopped" [ style = bold]
 "child_DoFencing:1_monitor_0 c001n03" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:1_monitor_0 c001n08" -> "DoFencing_start_0" [ style = bold]
+"child_DoFencing:1_monitor_0 c001n08" -> "all_stopped" [ style = bold]
 "child_DoFencing:1_monitor_0 c001n08" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:1_monitor_5000 c001n01" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:1_start_0 c001n01" -> "DoFencing_running_0" [ style = bold]
 "child_DoFencing:1_start_0 c001n01" -> "child_DoFencing:1_monitor_5000 c001n01" [ style = bold]
 "child_DoFencing:1_start_0 c001n01" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:2_monitor_0 c001n01" -> "DoFencing_start_0" [ style = bold]
+"child_DoFencing:2_monitor_0 c001n01" -> "all_stopped" [ style = bold]
 "child_DoFencing:2_monitor_0 c001n01" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:2_monitor_0 c001n03" -> "DoFencing_start_0" [ style = bold]
+"child_DoFencing:2_monitor_0 c001n03" -> "all_stopped" [ style = bold]
 "child_DoFencing:2_monitor_0 c001n03" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:2_monitor_0 c001n08" -> "DoFencing_start_0" [ style = bold]
+"child_DoFencing:2_monitor_0 c001n08" -> "all_stopped" [ style = bold]
 "child_DoFencing:2_monitor_0 c001n08" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:2_monitor_5000 c001n08" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:2_start_0 c001n08" -> "DoFencing_running_0" [ style = bold]
 "child_DoFencing:2_start_0 c001n08" -> "child_DoFencing:2_monitor_5000 c001n08" [ style = bold]
 "child_DoFencing:2_start_0 c001n08" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:3_monitor_0 c001n01" -> "DoFencing_start_0" [ style = bold]
+"child_DoFencing:3_monitor_0 c001n01" -> "all_stopped" [ style = bold]
 "child_DoFencing:3_monitor_0 c001n01" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:3_monitor_0 c001n03" -> "DoFencing_start_0" [ style = bold]
+"child_DoFencing:3_monitor_0 c001n03" -> "all_stopped" [ style = bold]
 "child_DoFencing:3_monitor_0 c001n03" [ style=bold color="green" fontcolor="black" ]
 "child_DoFencing:3_monitor_0 c001n08" -> "DoFencing_start_0" [ style = bold]
+"child_DoFencing:3_monitor_0 c001n08" -> "all_stopped" [ style = bold]
 "child_DoFencing:3_monitor_0 c001n08" [ style=bold color="green" fontcolor="black" ]
+"rsc_c001n01_monitor_0 c001n01" -> "all_stopped" [ style = bold]
 "rsc_c001n01_monitor_0 c001n01" -> "rsc_c001n01_start_0 c001n01" [ style = bold]
 "rsc_c001n01_monitor_0 c001n01" [ style=bold color="green" fontcolor="black" ]
+"rsc_c001n01_monitor_0 c001n03" -> "all_stopped" [ style = bold]
 "rsc_c001n01_monitor_0 c001n03" -> "rsc_c001n01_start_0 c001n01" [ style = bold]
 "rsc_c001n01_monitor_0 c001n03" [ style=bold color="green" fontcolor="black" ]
+"rsc_c001n01_monitor_0 c001n08" -> "all_stopped" [ style = bold]
 "rsc_c001n01_monitor_0 c001n08" -> "rsc_c001n01_start_0 c001n01" [ style = bold]
 "rsc_c001n01_monitor_0 c001n08" [ style=bold color="green" fontcolor="black" ]
 "rsc_c001n01_monitor_5000 c001n01" [ style=bold color="green" fontcolor="black" ]
 "rsc_c001n01_start_0 c001n01" -> "rsc_c001n01_monitor_5000 c001n01" [ style = bold]
 "rsc_c001n01_start_0 c001n01" [ style=bold color="green" fontcolor="black" ]
+"rsc_c001n02_monitor_0 c001n01" -> "all_stopped" [ style = bold]
 "rsc_c001n02_monitor_0 c001n01" -> "rsc_c001n02_start_0 c001n01" [ style = bold]
 "rsc_c001n02_monitor_0 c001n01" [ style=bold color="green" fontcolor="black" ]
+"rsc_c001n02_monitor_0 c001n03" -> "all_stopped" [ style = bold]
 "rsc_c001n02_monitor_0 c001n03" -> "rsc_c001n02_start_0 c001n01" [ style = bold]
 "rsc_c001n02_monitor_0 c001n03" [ style=bold color="green" fontcolor="black" ]
+"rsc_c001n02_monitor_0 c001n08" -> "all_stopped" [ style = bold]
 "rsc_c001n02_monitor_0 c001n08" -> "rsc_c001n02_start_0 c001n01" [ style = bold]
 "rsc_c001n02_monitor_0 c001n08" [ style=bold color="green" fontcolor="black" ]
 "rsc_c001n02_monitor_5000 c001n01" [ style=bold color="green" fontcolor="black" ]
 "rsc_c001n02_start_0 c001n01" -> "rsc_c001n02_monitor_5000 c001n01" [ style = bold]
 "rsc_c001n02_start_0 c001n01" [ style=bold color="green" fontcolor="black" ]
+"rsc_c001n03_monitor_0 c001n01" -> "all_stopped" [ style = bold]
 "rsc_c001n03_monitor_0 c001n01" -> "rsc_c001n03_start_0 c001n03" [ style = bold]
 "rsc_c001n03_monitor_0 c001n01" [ style=bold color="green" fontcolor="black" ]
+"rsc_c001n03_monitor_0 c001n03" -> "all_stopped" [ style = bold]
 "rsc_c001n03_monitor_0 c001n03" -> "rsc_c001n03_start_0 c001n03" [ style = bold]
 "rsc_c001n03_monitor_0 c001n03" [ style=bold color="green" fontcolor="black" ]
+"rsc_c001n03_monitor_0 c001n08" -> "all_stopped" [ style = bold]
 "rsc_c001n03_monitor_0 c001n08" -> "rsc_c001n03_start_0 c001n03" [ style = bold]
 "rsc_c001n03_monitor_0 c001n08" [ style=bold color="green" fontcolor="black" ]
 "rsc_c001n03_monitor_5000 c001n03" [ style=bold color="green" fontcolor="black" ]
 "rsc_c001n03_start_0 c001n03" -> "rsc_c001n03_monitor_5000 c001n03" [ style = bold]
 "rsc_c001n03_start_0 c001n03" [ style=bold color="green" fontcolor="black" ]
+"rsc_c001n08_monitor_0 c001n01" -> "all_stopped" [ style = bold]
 "rsc_c001n08_monitor_0 c001n01" -> "rsc_c001n08_start_0 c001n08" [ style = bold]
 "rsc_c001n08_monitor_0 c001n01" [ style=bold color="green" fontcolor="black" ]
+"rsc_c001n08_monitor_0 c001n03" -> "all_stopped" [ style = bold]
 "rsc_c001n08_monitor_0 c001n03" -> "rsc_c001n08_start_0 c001n08" [ style = bold]
 "rsc_c001n08_monitor_0 c001n03" [ style=bold color="green" fontcolor="black" ]
+"rsc_c001n08_monitor_0 c001n08" -> "all_stopped" [ style = bold]
 "rsc_c001n08_monitor_0 c001n08" -> "rsc_c001n08_start_0 c001n08" [ style = bold]
 "rsc_c001n08_monitor_0 c001n08" [ style=bold color="green" fontcolor="black" ]
 "rsc_c001n08_monitor_5000 c001n08" [ style=bold color="green" fontcolor="black" ]
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/rec-node-12.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/rec-node-12.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/rec-node-12.exp
@@ -592,6 +592,87 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="2" operation="monitor" operation_key="DcIPaddr_monitor_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="3" operation="monitor" operation_key="rsc_c001n08_monitor_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="4" operation="monitor" operation_key="rsc_c001n02_monitor_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="5" operation="monitor" operation_key="rsc_c001n03_monitor_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="6" operation="monitor" operation_key="rsc_c001n01_monitor_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="7" operation="monitor" operation_key="child_DoFencing:0_monitor_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="8" operation="monitor" operation_key="child_DoFencing:1_monitor_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="9" operation="monitor" operation_key="child_DoFencing:2_monitor_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="10" operation="monitor" operation_key="child_DoFencing:3_monitor_0" on_node="c001n01" on_node_uuid="de937e3d-0309-4b5d-b85c-f96edc1ed8e3"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="11" operation="monitor" operation_key="DcIPaddr_monitor_0" on_node="c001n03" on_node_uuid="5d9a8c11-8684-43ea-91.0.6e221530c193"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="12" operation="monitor" operation_key="rsc_c001n08_monitor_0" on_node="c001n03" on_node_uuid="5d9a8c11-8684-43ea-91.0.6e221530c193"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="13" operation="monitor" operation_key="rsc_c001n02_monitor_0" on_node="c001n03" on_node_uuid="5d9a8c11-8684-43ea-91.0.6e221530c193"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="14" operation="monitor" operation_key="rsc_c001n03_monitor_0" on_node="c001n03" on_node_uuid="5d9a8c11-8684-43ea-91.0.6e221530c193"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="15" operation="monitor" operation_key="rsc_c001n01_monitor_0" on_node="c001n03" on_node_uuid="5d9a8c11-8684-43ea-91.0.6e221530c193"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="16" operation="monitor" operation_key="child_DoFencing:0_monitor_0" on_node="c001n03" on_node_uuid="5d9a8c11-8684-43ea-91.0.6e221530c193"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="17" operation="monitor" operation_key="child_DoFencing:1_monitor_0" on_node="c001n03" on_node_uuid="5d9a8c11-8684-43ea-91.0.6e221530c193"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="18" operation="monitor" operation_key="child_DoFencing:2_monitor_0" on_node="c001n03" on_node_uuid="5d9a8c11-8684-43ea-91.0.6e221530c193"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="19" operation="monitor" operation_key="child_DoFencing:3_monitor_0" on_node="c001n03" on_node_uuid="5d9a8c11-8684-43ea-91.0.6e221530c193"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="20" operation="monitor" operation_key="DcIPaddr_monitor_0" on_node="c001n08" on_node_uuid="6427cb5a-c7a5-4bdf-9892-a04ce56f4e6b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="21" operation="monitor" operation_key="rsc_c001n08_monitor_0" on_node="c001n08" on_node_uuid="6427cb5a-c7a5-4bdf-9892-a04ce56f4e6b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="22" operation="monitor" operation_key="rsc_c001n02_monitor_0" on_node="c001n08" on_node_uuid="6427cb5a-c7a5-4bdf-9892-a04ce56f4e6b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="23" operation="monitor" operation_key="rsc_c001n03_monitor_0" on_node="c001n08" on_node_uuid="6427cb5a-c7a5-4bdf-9892-a04ce56f4e6b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="24" operation="monitor" operation_key="rsc_c001n01_monitor_0" on_node="c001n08" on_node_uuid="6427cb5a-c7a5-4bdf-9892-a04ce56f4e6b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="25" operation="monitor" operation_key="child_DoFencing:0_monitor_0" on_node="c001n08" on_node_uuid="6427cb5a-c7a5-4bdf-9892-a04ce56f4e6b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="26" operation="monitor" operation_key="child_DoFencing:1_monitor_0" on_node="c001n08" on_node_uuid="6427cb5a-c7a5-4bdf-9892-a04ce56f4e6b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="27" operation="monitor" operation_key="child_DoFencing:2_monitor_0" on_node="c001n08" on_node_uuid="6427cb5a-c7a5-4bdf-9892-a04ce56f4e6b"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="28" operation="monitor" operation_key="child_DoFencing:3_monitor_0" on_node="c001n08" on_node_uuid="6427cb5a-c7a5-4bdf-9892-a04ce56f4e6b"/>
+      </trigger>
+      <trigger>
         <pseudo_event id="49" operation="stonith_complete" operation_key="stonith_complete"/>
       </trigger>
     </inputs>
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/rec-node-15.dot
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/rec-node-15.dot
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/rec-node-15.dot
@@ -76,8 +76,10 @@ digraph "g" {
 "oralsnr_25_start_0 sapcl01" [ style=bold color="green" fontcolor="black" ]
 "stonith 'reboot' sapcl03" -> "stonith_complete" [ style = bold]
 "stonith 'reboot' sapcl03" [ style=bold color="green" fontcolor="black"]
+"stonith-1_monitor_0 sapcl01" -> "all_stopped" [ style = bold]
 "stonith-1_monitor_0 sapcl01" -> "stonith-1_start_0 sapcl01" [ style = bold]
 "stonith-1_monitor_0 sapcl01" [ style=bold color="green" fontcolor="black" ]
+"stonith-1_monitor_0 sapcl02" -> "all_stopped" [ style = bold]
 "stonith-1_monitor_0 sapcl02" -> "stonith-1_start_0 sapcl01" [ style = bold]
 "stonith-1_monitor_0 sapcl02" [ style=bold color="green" fontcolor="black" ]
 "stonith-1_start_0 sapcl01" [ style=bold color="green" fontcolor="black" ]
Index: pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/rec-node-15.exp
===================================================================
--- pacemaker-1.1.19+20181105.ccd6b5b10.orig/pengine/test10/rec-node-15.exp
+++ pacemaker-1.1.19+20181105.ccd6b5b10/pengine/test10/rec-node-15.exp
@@ -457,6 +457,12 @@
     </action_set>
     <inputs>
       <trigger>
+        <rsc_op id="9" operation="monitor" operation_key="stonith-1_monitor_0" on_node="sapcl01" on_node_uuid="85180fd0-70c9-4136-a5e0-90d89ea6079d"/>
+      </trigger>
+      <trigger>
+        <rsc_op id="10" operation="monitor" operation_key="stonith-1_monitor_0" on_node="sapcl02" on_node_uuid="09fa194c-d7e1-41fa-a0d0-afd79a139181"/>
+      </trigger>
+      <trigger>
         <rsc_op id="22" operation="stop" operation_key="IPaddr_192_168_1_102_stop_0" on_node="sapcl02" on_node_uuid="09fa194c-d7e1-41fa-a0d0-afd79a139181"/>
       </trigger>
       <trigger>
